/*    */ package org.hibernate.cfg;
/*    */ 
/*    */ import javax.persistence.DiscriminatorColumn;
/*    */ import javax.persistence.DiscriminatorType;
/*    */ import org.hibernate.AssertionFailure;
/*    */ import org.hibernate.annotations.DiscriminatorFormula;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class Ejb3DiscriminatorColumn
/*    */   extends Ejb3Column
/*    */ {
/*    */   private static final String DEFAULT_DISCRIMINATOR_COLUMN_NAME = "DTYPE";
/*    */   private static final String DEFAULT_DISCRIMINATOR_TYPE = "string";
/*    */   private String discriminatorTypeName;
/*    */   private static final int DEFAULT_DISCRIMINATOR_LENGTH = 31;
/*    */   
/*    */   public Ejb3DiscriminatorColumn()
/*    */   {
/* 27 */     setLogicalColumnName("DTYPE");
/* 28 */     setNullable(false);
/* 29 */     setDiscriminatorTypeName("string");
/* 30 */     setLength(31);
/*    */   }
/*    */   
/*    */   public String getDiscriminatorTypeName() {
/* 34 */     return this.discriminatorTypeName;
/*    */   }
/*    */   
/*    */   public void setDiscriminatorTypeName(String discriminatorTypeName) {
/* 38 */     this.discriminatorTypeName = discriminatorTypeName;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public static Ejb3DiscriminatorColumn buildDiscriminatorColumn(DiscriminatorType type, DiscriminatorColumn discAnn, DiscriminatorFormula discFormulaAnn, ExtendedMappings mappings)
/*    */   {
/* 45 */     Ejb3DiscriminatorColumn discriminatorColumn = new Ejb3DiscriminatorColumn();
/* 46 */     discriminatorColumn.setMappings(mappings);
/* 47 */     discriminatorColumn.setImplicit(true);
/* 48 */     if (discFormulaAnn != null) {
/* 49 */       discriminatorColumn.setImplicit(false);
/* 50 */       discriminatorColumn.setFormula(discFormulaAnn.value());
/*    */     }
/* 52 */     else if (discAnn != null) {
/* 53 */       discriminatorColumn.setImplicit(false);
/* 54 */       if (!BinderHelper.isDefault(discAnn.columnDefinition())) {
/* 55 */         discriminatorColumn.setSqlType(discAnn.columnDefinition());
/*    */       }
/*    */       
/*    */ 
/* 59 */       if (!BinderHelper.isDefault(discAnn.name())) {
/* 60 */         discriminatorColumn.setLogicalColumnName(discAnn.name());
/*    */       }
/* 62 */       discriminatorColumn.setNullable(false);
/*    */     }
/* 64 */     if (DiscriminatorType.CHAR.equals(type)) {
/* 65 */       discriminatorColumn.setDiscriminatorTypeName("character");
/* 66 */       discriminatorColumn.setImplicit(false);
/*    */     }
/* 68 */     else if (DiscriminatorType.INTEGER.equals(type)) {
/* 69 */       discriminatorColumn.setDiscriminatorTypeName("integer");
/* 70 */       discriminatorColumn.setImplicit(false);
/*    */     }
/* 72 */     else if ((DiscriminatorType.STRING.equals(type)) || (type == null)) {
/* 73 */       if (discAnn != null) discriminatorColumn.setLength(discAnn.length());
/* 74 */       discriminatorColumn.setDiscriminatorTypeName("string");
/*    */     }
/*    */     else {
/* 77 */       throw new AssertionFailure("Unknown discriminator type: " + type);
/*    */     }
/* 79 */     discriminatorColumn.bind();
/* 80 */     return discriminatorColumn;
/*    */   }
/*    */ }


/* Location:              C:\Users\anandkum\Desktop\source\hibernate-annotations-3.3.1.GA.jar!\org\hibernate\cfg\Ejb3DiscriminatorColumn.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */